/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.lang;

import java.util.Dictionary;
import java.util.Hashtable;

/**
 * native methods  allocate  handle  GC ǲʤ褦
 * ݻ륯饹<BR>
 * Υ饹Υ᥽åɤ handle.c ͳ native methods ƤФ롣
 *  JNI  NewGlobalRef(), DeleteGlobalRef() Ȥ٤
 */
public final
class GlobalReference {
  public static final String CLASSNAME =
	"NET.shudo.moba.lang.GlobalReference";

  // class GlobalReference ʤ褦ݻ
  private static Class globalRef = null;

  static Dictionary handleTable = new Hashtable();

  public static void register(Object obj) {
    handleTable.put(obj, obj);
  }

  public static Object remove(Object obj) {
    return handleTable.remove(obj);
  }

  public static void reset() {
    handleTable = new Hashtable();
  }


  // 饤֥ΰ
  private static boolean libLoaded = false;
  private static Object libLoadedLock = new Object();

  /**
   * native methods ޤ饤֥ɤ롣
   */
  public static void loadLibrary() {
    synchronized(libLoadedLock) {
      if (!libLoaded) {
	// native method 饤֥Υ
	System.loadLibrary("Moba");
	libLoaded = true;

	// global handle holder ݻƤ
	try {
	  globalRef = Class.forName(GlobalReference.CLASSNAME);
	}
	catch (ClassNotFoundException e) { /* not reached. */ }
      }
    }
  }
}
