# Common stuffs for Makefiles for MC system
# $Id$

# Java related
#  JDK_VER is for native methods

# with JDK 1.0.2
#J_HOME = /usr/local/java
#JDK_VER = 102

# with JDK 1.1.5
#J_HOME = /usr/local/java
J_HOME = /usr/local/jdk1.1.5
JDK_VER = 115

# with JDK 1.2beta2
#J_HOME = /usr/local/jdk1.2beta2
#JDK_VER = 120


# commands
#  Java
JAVA = java
#JAVA = /usr/local/harissa/bin/hi

JAVAC = javac
#JAVAC = /usr/local/toba/bin/xjavac
#JAVAC = /usr/local/harissa/bin/cjavac
#JAVAC = /usr/local/javalib/jump/Jump

JAR = jar

JAVADOC = javadoc
#JAVADOC = /usr/local/toba/bin/xjavadoc
#JAVADOC = /usr/local/harissa/bin/cjavadoc

JAVACUP = $(JAVA) java_cup.Main
#JAVACUP = /usr/local/toba/bin/xjava_cup
#JAVACUP = /usr/local/harissa/bin/cjava_cup

JAVAH = javah

#  C
CC = gcc
LD_DYNAMIC = gcc -shared#	for SunOS 5, Linux
#LD_DYNAMIC = ld -Bdynamic#	for SunOS 4

#  misc
RM = rm -f
MKDIR = mkdir -p
LN = ln
AR = ar
RANLIB = ranlib
INSTALL = install -c
CO = co
CI = ci
WC = wc
TEE = tee
ETAGS = etags
RLOG = rlog -h
ZIP = zip -0


# Defaults

COMPILE.java = $(JAVAC) $(JFLAGS)

# Rules
.java.class:
	$(COMPILE.java) $<

%.class: %.java
	$(COMPILE.java) $<

# for 'make classname'
%: %.java
	$(COMPILE.java) $<

# for CUP
%.java: %.cup
	$(JAVACUP) < $<
#%.java: %.cup
#	$(JAVACUP) -dump_status < $< | $(TEE) `basename $@ .java`.status 2>&1
